<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>Cache the result of an expression — with_cache • pkgpins</title><script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Cache the result of an expression — with_cache"><meta name="description" content="One-stop solution to add caching to any R expression, for example from within a function. See the examples."><meta property="og:description" content="One-stop solution to add caching to any R expression, for example from within a function. See the examples."><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">pkgpins</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.8.0.9000</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="active nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/rpkg.dev/pkgpins/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-reference-topic">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Cache the result of an expression</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/rpkg.dev/pkgpins/blob/HEAD/R/pkgpins.gen.R" class="external-link"><code>R/pkgpins.gen.R</code></a></small>
      <div class="d-none name"><code>with_cache.Rd</code></div>
    </div>

    <div class="ref-description section level2">
    <p>One-stop solution to add caching to any R expression, for example from within a function. See the examples.</p>
    </div>

    <div class="section level2">
    <h2 id="ref-usage">Usage<a class="anchor" aria-label="anchor" href="#ref-usage"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span><span class="fu">with_cache</span><span class="op">(</span></span>
<span>  <span class="va">expr</span>,</span>
<span>  <span class="va">pkg</span>,</span>
<span>  <span class="va">from_fn</span>,</span>
<span>  <span class="va">...</span>,</span>
<span>  pkg_versioned <span class="op">=</span> <span class="cn">TRUE</span>,</span>
<span>  use_cache <span class="op">=</span> <span class="cn">TRUE</span>,</span>
<span>  max_cache_age <span class="op">=</span> <span class="st">"1 day"</span></span>
<span><span class="op">)</span></span></code></pre></div>
    </div>

    <div class="section level2">
    <h2 id="arguments">Arguments<a class="anchor" aria-label="anchor" href="#arguments"></a></h2>


<dl><dt id="arg-expr">expr<a class="anchor" aria-label="anchor" href="#arg-expr"></a></dt>
<dd><p>Expression to cache.</p></dd>


<dt id="arg-pkg">pkg<a class="anchor" aria-label="anchor" href="#arg-pkg"></a></dt>
<dd><p>Package name. A character scalar.</p></dd>


<dt id="arg-from-fn">from_fn<a class="anchor" aria-label="anchor" href="#arg-from-fn"></a></dt>
<dd><p>Name of the function that <code>expr</code> is cached from, i.e. the name of the function that <code>with_cache()</code> is called from. A character scalar.</p></dd>


<dt id="arg--">...<a class="anchor" aria-label="anchor" href="#arg--"></a></dt>
<dd><p>Arguments received by <code>from_fn</code> on which the caching should depend. This is fundamental to determine whether <code>expr</code> was already cached or not. The
arguments must be specified <em>unnamed</em> (see examples). <a href="https://rlang.r-lib.org/reference/dyn-dots.html" class="external-link">Dynamic dots</a> are supported.</p></dd>


<dt id="arg-pkg-versioned">pkg_versioned<a class="anchor" aria-label="anchor" href="#arg-pkg-versioned"></a></dt>
<dd><p>Whether or not to make the caching dependent on the version number of <code>pkg</code>. If <code>FALSE</code>, caching is agnostic about <code>pkg</code>'s version
number. Otherwise, a separate user-cache pins board is created each time <code>pkg</code>'s version number changes (e.g. after an upgrade), ensuring to never return
cached results from a different (old) package version, irrespective of <code>max_cache_age</code>.</p></dd>


<dt id="arg-use-cache">use_cache<a class="anchor" aria-label="anchor" href="#arg-use-cache"></a></dt>
<dd><p>Whether or not to return cached results if possible. If <code>FALSE</code>, results are always newly fetched regardless of <code>max_cache_age</code>.</p></dd>


<dt id="arg-max-cache-age">max_cache_age<a class="anchor" aria-label="anchor" href="#arg-max-cache-age"></a></dt>
<dd><p>Duration after which cached results are refreshed (i.e. newly fetched). A valid <a href="https://lubridate.tidyverse.org/reference/as.duration.html" class="external-link">lubridate duration</a>. Use <code>Inf</code> to disable cache expiry. Only relevant if <code>use_cache = TRUE</code>.</p></dd>

</dl></div>
    <div class="section level2">
    <h2 id="value">Value<a class="anchor" aria-label="anchor" href="#value"></a></h2>
    <p>The result of evaluating <code>expr</code>, from cache if <code>use_cache = TRUE</code> and a cached result exists that hasn't exceeded <code>max_cache_age</code>.</p>
    </div>
    <div class="section level2">
    <h2 id="details">Details<a class="anchor" aria-label="anchor" href="#details"></a></h2>
    <p><code>expr</code> is evaluated in the environment that <code>with_cache()</code> is called from.</p>
<p>See <code><a href="hash_fn_call.html">hash_fn_call()</a></code> for details about how the pin name is constructed that uniquely identifies <code>expr</code> in the <code>pkg</code>'s user-cache pins board.</p>
    </div>
    <div class="section level2">
    <h2 id="see-also">See also<a class="anchor" aria-label="anchor" href="#see-also"></a></h2>
    <div class="dont-index"><p>Other high-level functions:
<code><a href="cachely.html">cachely</a>()</code></p></div>
    </div>

    <div class="section level2">
    <h2 id="ref-examples">Examples<a class="anchor" aria-label="anchor" href="#ref-examples"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span class="r-in"><span><span class="co"># if the fn below would be part of a real package, we could instead define `this_pkg` globally</span></span></span>
<span class="r-in"><span><span class="co"># using `this_pkg &lt;- utils::packageName()`; instead, we now cache to pkgpins's cache (which</span></span></span>
<span class="r-in"><span><span class="co"># itself never uses the cache)</span></span></span>
<span class="r-in"><span><span class="va">this_pkg</span> <span class="op">&lt;-</span> <span class="st">"pkgpins"</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># let's define a fn that returns R pkg sys deps, cached</span></span></span>
<span class="r-in"><span><span class="va">pkg_sys_deps</span> <span class="op">&lt;-</span> <span class="kw">function</span><span class="op">(</span><span class="va">pkg</span>,</span></span>
<span class="r-in"><span>                         <span class="va">os</span> <span class="op">=</span> <span class="st">"ubuntu"</span>,</span></span>
<span class="r-in"><span>                         <span class="va">os_version</span> <span class="op">=</span> <span class="st">"24.04"</span>,</span></span>
<span class="r-in"><span>                         <span class="va">use_cache</span> <span class="op">=</span> <span class="cn">TRUE</span>,</span></span>
<span class="r-in"><span>                         <span class="va">max_cache_age</span> <span class="op">=</span> <span class="st">"6h"</span><span class="op">)</span> <span class="op">{</span></span></span>
<span class="r-in"><span>  <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu">with_cache</span><span class="op">(</span></span></span>
<span class="r-in"><span>    expr <span class="op">=</span> <span class="fu">purrr</span><span class="fu">::</span><span class="fu"><a href="https://purrr.tidyverse.org/reference/list_flatten.html" class="external-link">list_flatten</a></span><span class="op">(</span><span class="fu">jsonlite</span><span class="fu">::</span><span class="fu"><a href="https://rdrr.io/pkg/jsonlite/man/fromJSON.html" class="external-link">fromJSON</a></span><span class="op">(</span></span></span>
<span class="r-in"><span>      txt <span class="op">=</span> <span class="fu">glue</span><span class="fu">::</span><span class="fu"><a href="https://glue.tidyverse.org/reference/glue.html" class="external-link">glue</a></span><span class="op">(</span><span class="st">"https://packagemanager.posit.co/__api__/repos/2/sysreqs"</span>,</span></span>
<span class="r-in"><span>                       <span class="st">"?all=false&amp;pkgname={pkg}&amp;distribution={os}&amp;release={os_version}"</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>      simplifyVector <span class="op">=</span> <span class="cn">FALSE</span></span></span>
<span class="r-in"><span>    <span class="op">)</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>    pkg <span class="op">=</span> <span class="va">this_pkg</span>,</span></span>
<span class="r-in"><span>    from_fn <span class="op">=</span> <span class="st">"pkg_sys_deps"</span>,</span></span>
<span class="r-in"><span>    <span class="va">pkg</span>,</span></span>
<span class="r-in"><span>    use_cache <span class="op">=</span> <span class="va">use_cache</span>,</span></span>
<span class="r-in"><span>    max_cache_age <span class="op">=</span> <span class="va">max_cache_age</span></span></span>
<span class="r-in"><span>  <span class="op">)</span></span></span>
<span class="r-in"><span><span class="op">}</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># now get the sys deps for git2r for the first time (populating the cache)</span></span></span>
<span class="r-in"><span><span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$name</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "git2r"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$packages</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$packages[[1]]</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "libgit2-dev"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$install_scripts</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> $requirements$requirements$install_scripts[[1]]</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [1] "apt-get install -y libgit2-dev"</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> </span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="kw">if</span> <span class="op">(</span><span class="cn">FALSE</span><span class="op">)</span> <span class="op">{</span> <span class="co"># \dontrun{</span></span></span>
<span class="r-in"><span><span class="co"># for the `max_cache_age` (we've set a default of 6h), the cached result will be returned</span></span></span>
<span class="r-in"><span><span class="co"># (as long as `use_cache = TRUE`):</span></span></span>
<span class="r-in"><span><span class="fu">bench</span><span class="fu">::</span><span class="fu"><a href="http://bench.r-lib.org/reference/mark.html" class="external-link">mark</a></span><span class="op">(</span><span class="st">"with cache"</span> <span class="op">=</span> <span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>            <span class="st">"without cache"</span> <span class="op">=</span> <span class="fu">pkg_sys_deps</span><span class="op">(</span><span class="st">"git2r"</span>, use_cache <span class="op">=</span> <span class="cn">FALSE</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>            iterations <span class="op">=</span> <span class="fl">10</span>,</span></span>
<span class="r-in"><span>            relative <span class="op">=</span> <span class="cn">TRUE</span><span class="op">)</span><span class="op">}</span> <span class="co"># }</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># purge cache from the above example</span></span></span>
<span class="r-in"><span><span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="board.html">board</a></span><span class="op">(</span>pkg <span class="op">=</span> <span class="st">"pkgpins"</span><span class="op">)</span> <span class="op">|&gt;</span> <span class="fu">pkgpins</span><span class="fu">::</span><span class="fu"><a href="purge_cache.html">purge_cache</a></span><span class="op">(</span><span class="op">)</span></span></span>
</code></pre></div>
    </div>
  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.</p>
</div>

    </footer></div>





  </body></html>

